
function dinorobot_shot_fly1()
	local explosion = uniGetExecutor()
	explosion:setTransformOwner()
	local mshotsmoke = explosion:addSimpleEffect(ENET_EFFECT_PS_DINOROBOTSHOT_SMOKE)
	local mshot1 = explosion:addSimpleEffect(ENET_EFFECT_SP_DINOROBOTSHOT_FLY)
	local shotlight = explosion:addSimpleEffect(ENET_EFFECT_DINOROBOT_LIGHTSPOT)
	waitDeath(explosion:addMoveEffect(ENET_EFFECT_MOVE_LINEARFLY,250,uniGetTarget()),1000)
	uniGetTarget():executeCommand(ENC_DAMAGED)
	mshot1:destroy()
	mshotsmoke:suspendedDestroy(1.5)
	local exp_ps = explosion:addSimpleEffect(ENET_EFFECT_PS_DOTALIENSHOT_EXPLOSION)
	exp_ps:suspendedDestroy(2.5)
	shotlight:suspendedDestroy(1.5)
	pause(1.5)
	explosion:suspendedDestroy(2.0)
end

function dinorobot_shot_fly2()
	local explosion = uniGetExecutor()
	explosion:setTransformOwner()
	local mshot1 = explosion:addSimpleEffect(ENET_EFFECT_PS_DINOROBOTSHOT_FLY)
	local light = explosion:addSimpleEffect(ENET_EFFECT_DINOROBOT_LIGHTSPOT2)
	waitDeath(explosion:parabolicFly(uniGetTarget()))
	mshot1:suspendedDestroy(2.0)
	uniGetTarget():executeCommand(ENC_DAMAGED)
	local exp_ps = explosion:addSimpleEffect(ENET_EFFECT_PS_DINOROBOTSHOT_EXPLOSION)
	pause(1.0)
	exp_ps:suspendedDestroy(1.5)
	light:destroy()
	pause(1.5)
	explosion:destroy()
end

registerCommand(ENSCRIPTSET_DINOROBOTSHOT,ENC_FIRE1,"dinorobot_shot_fly1")
registerCommand(ENSCRIPTSET_DINOROBOTSHOT2,ENC_FIRE2,"dinorobot_shot_fly2")

--
-- dummy effect creation test
--
desc = getEffectDescriptionP(ENET_EFFECT_DINOROBOTSHOT_FLY)
desc.ClassID = ENCLASS_DUMMY
desc.EffectClassType = ENECT_GEOMETRY

desc.ScriptSet = ENSCRIPTSET_DINOROBOTSHOT
desc.RelativePosition = ENLOCALPOS_NOTSPECIFIED
local vzbzd1 = D3DXVECTOR3:new(0,0,0)
desc.LocalPosition = vzbzd1
vzbzd1:delete()
desc.MoveType = ENMOVE_FLY

desc.ActivityType = ENACT_COMMANDSEMIACTIVE
--
-- end dummy effect creation test
--



--
-- dummy effect creation test
--
desc = getEffectDescriptionP(ENET_EFFECT_DINOROBOTSHOT_FLY2)
desc.ClassID = ENCLASS_DUMMY
desc.EffectClassType = ENECT_GEOMETRY

desc.ScriptSet = ENSCRIPTSET_DINOROBOTSHOT2
desc.RelativePosition = ENLOCALPOS_NOTSPECIFIED
local vzbzd2 = D3DXVECTOR3:new(0,0,0)
desc.LocalPosition = vzbzd2
vzbzd2:delete()
desc.MoveType = ENMOVE_FLY

desc.ActivityType = ENACT_COMMANDSEMIACTIVE
--
-- end dummy effect creation test
--


--
-- lightsource creation test
--
desc = getEffectDescriptionP(ENET_EFFECT_DINOROBOT_LIGHTSPOT)
desc.ClassID = ENCLASS_LIGHTSOURCE
desc.EffectClassType = ENECT_LIGHTSOURCE

desc.ScriptSet = ENSCRIPTSET_UNKNOWN
desc.RelativePosition = ENLOCALPOS_NOTSPECIFIED
local vzbzd3 = D3DXVECTOR3:new(0,0,0)
desc.LocalPosition = vzbzd3
vzbzd3:delete()
desc.ActivityType = ENACT_SEMIACTIVE

-- add interpolators
desc:clearInterpolators()

local interpolator = createInterpolator()
interpolator:addKey(0.0,70.0)
interpolator:addKey(1.0,70.0)
interpolator:finalize(false)
-- add interpolator on light range
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_LIGHT_RANGE))

local interpolator = createInterpolator()
interpolator:addKey(0.0,0.1)
interpolator:addKey(1.0,0.1)
interpolator:finalize(false)
-- add interpolator on R B colors
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_R))
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_B))
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_G))


--
-- end lightsource creation description
--


--
-- lightsource creation test
--
desc = getEffectDescriptionP(ENET_EFFECT_DINOROBOT_LIGHTSPOT2)
desc.ClassID = ENCLASS_LIGHTSOURCE
desc.EffectClassType = ENECT_LIGHTSOURCE

desc.ScriptSet = ENSCRIPTSET_UNKNOWN
desc.RelativePosition = ENLOCALPOS_NOTSPECIFIED
local vzbzd4 = D3DXVECTOR3:new(0,0,0)
desc.LocalPosition = vzbzd4
vzbzd4:delete()
desc.ActivityType = ENACT_SEMIACTIVE

-- add interpolators
--desc.clearInterpolators()

local interpolator = createInterpolator()
interpolator:addKey(0.0,20.0)
interpolator:addKey(2.0,70.0)
interpolator:addKey(4.0,20.0)
interpolator:addKey(10.0,20.0)
interpolator:finalize(false)
-- add interpolator on light range
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_LIGHT_RANGE))

local interpolator = createInterpolator()
interpolator:addKey(0.0,1.0)
interpolator:addKey(4.0,1.0)
interpolator:finalize(false)
-- add interpolator on R B colors
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_R))
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_B))
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_G))
--
-- end lightsource creation description
--



--
-- oriented sprite with interpolator
--
desc = getEffectDescriptionP(ENET_EFFECT_SP_DINOROBOTSHOT_FLY)

desc.ClassID = ENCLASS_ORIENTEDSPRITE
desc.EffectClassType = ENECT_ORIENTEDSPRITE



desc.ScriptSet = ENSCRIPTSET_UNKNOWN
desc.FileName = "dinorobot_effect_firetrace.dds"
desc.RelativePosition = ENLOCALPOS_NOTSPECIFIED
local vzbzd5 = D3DXVECTOR3:new(0,0,0)
desc.LocalPosition = vzbzd5
vzbzd5:delete()
desc.isAnimateTexture = false

desc.Material = ENMAT_PARTICLE_LIGHT
desc.MaterialColors.Ambient.r = 0
desc.MaterialColors.Ambient.g = 0
desc.MaterialColors.Ambient.b = 0
desc.MaterialColors.Ambient.a = 1
desc.MaterialColors.Diffuse.r = 0
desc.MaterialColors.Diffuse.g = 0
desc.MaterialColors.Diffuse.b = 0
desc.MaterialColors.Diffuse.a = 1
desc.MaterialColors.Emissive.r = 1
desc.MaterialColors.Emissive.g = 1
desc.MaterialColors.Emissive.b = 1
desc.MaterialColors.Emissive.a = 1
desc.RenderType = ENRENDERTYPE_GEOMETRY

spdesc = desc.OrientedSprite
spdesc.SpriteType = EN3DSPRITE_ORIENTED
spdesc.xsize = 4
spdesc.ysize = 64
local vzbzd6 = D3DXVECTOR3:new(0,0,1)
spdesc.OrientAxis = vzbzd6
vzbzd6:delete()
local vzbzd7 = D3DXVECTOR3:new(1,0,0)
spdesc.BindAxis = vzbzd7
vzbzd7:delete()
spdesc.Centering = ENCENTERING_CENTER
spdesc.IsTargetted = false
spdesc.TargetRelativePosition = ENLOCALPOS_NOTSPECIFIED
spdesc.IsAxisInLocalSpace = true

interpolator = createInterpolator()
interpolator:addKey(0.0,0.0)
interpolator:addKey(0.1,0.5)
interpolator:addKey(1.0,0.0)
interpolator:finalize(false)
-- add interpolator on X scale
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_SCALE_X))

interpolator = createInterpolator()
interpolator:addKey(0.0,0.0)
interpolator:addKey(0.1,0.5)
interpolator:addKey(1.0,0.0)
interpolator:finalize(false)
-- add interpolator on Y scale
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_SCALE_Y))


--
-- end sprite creation description
--
